--- (C) 2011 michael
--- zlib/libpng License
--- Simple utf8 manipulation functions

local function utf8len(str)
	local l = #str
	local i = 1
	local c = 0
	while i<=l do
		local byte = string.byte(str, i)
		if byte > 239 then     	i = i + 4
		elseif byte > 223 then	i = i + 3
		elseif byte > 191 then	i = i + 2
		else				    i = i + 1
		end
		c = c + 1
	end
	return c
end
if not string.utf8len then
	string.utf8len = utf8len
end

local function utf8pos(str, pos)
	local l = #str
	local i = 1
	local c = pos-1
	while c>0 and i<=l do
		local byte = string.byte(str, i)
		if byte > 239 then     	i = i + 4
		elseif byte > 223 then	i = i + 3
		elseif byte > 191 then	i = i + 2
		else				    i = i + 1
		end
		c = c - 1
	end
	return i
end
if not string.utf8pos then
	string.utf8pos = utf8pos
end

local function utf8sub(str, from, to)
	local l = #str
	local c = to and to-from+1 or l
	local j = from>1 and utf8pos(str, from) or 1
	local i = j
	while c>0 and i<=l do
		local byte = string.byte(str, i)
		if byte > 239 then     	i = i + 4
		elseif byte > 223 then	i = i + 3
		elseif byte > 191 then	i = i + 2
		else				    i = i + 1
		end
		c = c - 1
	end
	return str:sub(j, i-1)
end
if not string.utf8sub then
	string.utf8sub = utf8sub
end